﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            // Original-Source from IG-Sample: 
            //this.DataContext = CreateTable(4, 10).DefaultView;

            CreateGridLayout(grid, 4);
            grid.ItemsSource = CreateTable(4, 5).DefaultView;
        }

        private bool CreateGridLayout(XamGrid gridTable, int columns)
        {
            // Create the Grid-Layout
            gridTable.Columns.Clear();
            gridTable.ItemsSource = null;
            gridTable.HeaderRowHeight = RowHeight.Dynamic;

            for (int i = 0; i < columns; i++)
            {
                CheckBoxColumn chckcol = new CheckBoxColumn();
                chckcol.Key = "col" + (i + 1).ToString();
                chckcol.HeaderText = "Col" + (i+1).ToString();

                chckcol.EditorDisplayBehavior = EditorDisplayBehaviors.Always;
                gridTable.Columns.Add(chckcol);
            }

            return true;
        }

        public DataTable CreateTable(int columns, int rows)
        {
            DataTable d = new DataTable();
            // Original-Source from IG-Sample: 
            //Random r = new Random();

            for (int i = 0; i < columns; i++)
            {
                // Original-Source from IG-Sample: 
                //d.Columns.Add(new DataColumn("Column " + i, typeof(int)));

                //DataColumn col = new DataColumn("col" + (i + 1).ToString());
                //col.DataType = System.Type.GetType("System.Boolean");

                d.Columns.Add(new DataColumn("col" + (i + 1).ToString(), System.Type.GetType("System.Boolean")));
            }
            for (int i = 0; i < rows; i++)
            {
                DataRow row = d.NewRow();

                for (int j = 0; j < columns; j++)
                {
                    // Original-Source from IG-Sample: 
                    //row["Column " + j] = r.Next(1000 * i);
                    row[j] = false;
                }

                d.Rows.Add(row);
            }
            return d;
        }

        private void HeaderControl_PreviewMouseMove(object sender, MouseEventArgs e)
        {
            if ((sender as HeaderCellControl).Column.ColumnLayout.Columns.Where(t => (t as Column).IsSelected).Count() != 0
            && !(sender as HeaderCellControl).Column.ColumnLayout.Grid.SelectionSettings.SelectedColumns.Contains((sender as HeaderCellControl).Column)
            && e.LeftButton == MouseButtonState.Pressed
                && !Keyboard.IsKeyDown(Key.LeftCtrl))
            {
                (sender as HeaderCellControl).Column.ColumnLayout.Grid.SelectionSettings.SelectedColumns.Add((sender as HeaderCellControl).Column);
                //System.Diagnostics.Trace.WriteLine("HeaderControl_PreviewMouseMove:");
                //System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedColumns.Count: " + grid.SelectionSettings.SelectedColumns.Count.ToString());
                //Requirement for our Application: Selection of multiple rows in the same way it works for columns.
            }            
        }

        private void HeaderControl_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            if (!Keyboard.IsKeyDown(Key.LeftCtrl))
            {
                // Optimization from me
                //grid.SelectionSettings.SelectedCells.Clear();
                //grid.SelectionSettings.SelectedRows.Clear();
                //grid.SelectionSettings.SelectedColumns.Clear();

                (sender as HeaderCellControl).Column.ColumnLayout.Grid.SelectionSettings.SelectedColumns.Add((sender as HeaderCellControl).Column);
                //System.Diagnostics.Trace.WriteLine("HeaderControl_PreviewMouseDown:");
                //System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedColumns.Count: " + grid.SelectionSettings.SelectedColumns.Count.ToString());
                //Requirement for our Application: Selection of multiple rows in the same way it works for columns.
            }            
        }

        private void grid_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            System.Diagnostics.Trace.WriteLine("grid_PreviewKeyDown e.Key: " + e.Key.ToString());
            System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedCells.Count: " + grid.SelectionSettings.SelectedCells.Count.ToString());
            System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedRows.Count: " + grid.SelectionSettings.SelectedRows.Count.ToString());
            System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedColumns.Count: " + grid.SelectionSettings.SelectedColumns.Count.ToString());
            // SelectionSettings are still available!

            if (e.Key == Key.Space)
            {
                System.Diagnostics.Trace.WriteLine("  Key.Space was pressed!");
                // Question to IG: How could I prevent the actual behvior of XamGrid after pressing the Space key?
                //e.Cancel = true; 
                // ==> is not possible!
            }
        }

        private void XamGrid_KeyDown(object sender, KeyEventArgs e)
        {
            DataView dv = grid.ItemsSource as DataView;
            DataTable d = dv.Table as DataTable;

            System.Diagnostics.Trace.WriteLine("XamGrid_KeyDown e.Key: " + e.Key.ToString());
            System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedCells.Count: " + grid.SelectionSettings.SelectedCells.Count.ToString());
            System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedRows.Count: " + grid.SelectionSettings.SelectedRows.Count.ToString());
            System.Diagnostics.Trace.WriteLine("  grid.SelectionSettings.SelectedColumns.Count: " + grid.SelectionSettings.SelectedColumns.Count.ToString());

            //if (e.Key == Key.Space)
            //  Requirement for our Application: Toggle Check/Uncheck state of all CheckBoxes in the secected columns or rows by using the Space key!
            //  Status after receiving feedback from IG: 
            //  - SelectionSettings are still getting lost, when using this key! 
            //  - Reason unknown!
            //  - Solution unknown! Up to now, no proposal from IG.

            if (e.Key == Key.Add)
            {
                bool bCheck = false;
                bool bGetCheck = false;

                for (int r = 0; r < grid.SelectionSettings.SelectedRows.Count; r++)
                {
                    bGetCheck = false;
                    int ri = grid.SelectionSettings.SelectedRows[r].Index;
                    for (int c = 0; c < d.Rows[ri].ItemArray.AsEnumerable().Count(); c++)
                    {
                        // actual Check/Uncheck-state of first cell in selected row
                        if (!bGetCheck)
                        {
                            bCheck = (bool)d.Rows[ri].Field<bool>(c);
                            bGetCheck = true;
                        }
                        // toggle Check/Uncheck-state of all cells in the selected row
                        d.Rows[ri].SetField<bool>(c, !bCheck);
                    }
                }

                for (int c = 0; c < grid.SelectionSettings.SelectedColumns.Count; c++)
                {
                    bGetCheck = false;
                    string ckey = grid.SelectionSettings.SelectedColumns[c].Key;
                    for (int r = 0; r < d.Rows.Count; r++)
                    {
                        // actual Check/Uncheck-state of first cell in selected column
                        if (!bGetCheck)
                        {
                            bCheck = (bool)d.Rows[r].Field<bool>(ckey);
                            bGetCheck = true;
                        }
                        // toggle Check/Uncheck-state of all cells in the selected column
                        d.Rows[r].SetField<bool>(ckey, !bCheck);
                    }
                }

                for (int c = 0; c < grid.SelectionSettings.SelectedCells.Count; c++)
                {
                    string ckey = grid.SelectionSettings.SelectedCells[c].Column.Key;
                    int ri = grid.SelectionSettings.SelectedCells[c].Row.Index;                   

                    // actual Check/Uncheck-state of first cell in SelectedCells
                    if (!bGetCheck)
                    {
                        bCheck = (bool)d.Rows[ri].Field<bool>(ckey);
                        bGetCheck = true;
                    }
                    // toggle Check/Uncheck-state of all selected cells
                    d.Rows[ri].SetField<bool>(ckey, !bCheck);
                } 
            }
        }
    }
}
